Magellan Linux

Diff of /trunk/installer-simple/bin/installer.sh.in

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

revision 2332 by niro, Fri Jan 3 13:58:23 2014 UTC revision 2403 by niro, Tue Jan 7 13:18:21 2014 UTC
# Line 7  Line 7 
7  # Niels Rogalla <niro@magellan-linux.de>  # Niels Rogalla <niro@magellan-linux.de>
8  #  #
9    
10  source %SYSCONFDIR%/installer.conf  # ignore the environment
11    LC_ALL=C
12    # include dir
13    INSTALLER_LIBDIR="%LIBDIR%"
14    
15  #images: (get ${CDIMAGENAME})  # TOTALLINES=linecount of ${CDIMAGENAME}-tarball -1 !
16  source /mnt/cdrom/system/images.conf  # -> now in images.conf
17    CURRENTLINE=0
18    
19  #Includes  die()
20  source /usr/lib/installer/functions/findhdd.sh > /dev/null  {
21  ### bugfix ###############################   echo "Error: $@"
22  cdromdev="$(echo ${cdromdev} | sed 's/ //')"   exit 1
23  ########################################  }
24    
25    # load common includes
26    for inc in %SYSCONFDIR%/installer.conf \
27     ${INSTALLER_LIBDIR}/functions/common.sh \
28     ${INSTALLER_LIBDIR}/functions/common-dialogs.sh \
29     ${INSTALLER_LIBDIR}/functions/hwdetection.sh \
30     ${INSTALLER_LIBDIR}/functions/installer-dialogs.sh
31    do
32     if [ -e ${inc} ]
33     then
34     source "${inc}"
35     else
36     die "'${inc}' not found"
37     fi
38    done
39    
40    # TOTALLINES=linecount of ${CDIMAGENAME}-tarball -1 !
41    # -> now in images.conf
42    CDIMAGENAME=""
43    TOTALLINES=""
44    CURRENTLINE=0
45    if [ -e /mnt/cdrom/system/images.conf ]
46    then
47     source /mnt/cdrom/system/images.conf
48     # check if all required variables are set
49     [[ -z ${CDIMAGENAME} ]] && die "CDIMAGENAME is empty in /mnt/cdrom/system/images.conf"
50     [[ -z ${TOTALLINES} ]] && die "TOTALLINES is empty in /mnt/cdrom/system/images.conf"
51    else
52     die "/mnt/cdrom/system/images.conf not found"
53    fi
54    
55  ### System/Config Version  ### System/Config Version
56  VERSION="%VERSIONTAG%"  VERSION="%VERSIONTAG%"
57  TITLE="${DEFAULT_TITLE} - ${VERSION}"  TITLE="${DEFAULT_TITLE} - ${VERSION}"
58    
59  CDPATH="${DEFAULT_CDPATH}"  CDROOT="${DEFAULT_CDROOT}"
60  INSTALLPATH="${DEFAULT_INSTALLPATH}"  INSTALLROOT="${DEFAULT_INSTALLROOT}"
   
 ### WICHTIG: anzahl lines in der autosta_lx.tar.gz -1  
 CURRENTLINE=0  
 #TOTALLINES=11072 # -> now in images.conf  
61    
62  # standard kernel opts  # standard kernel opts
63  KERNELOPTS="quiet video=1024x768"  KERNELOPTS="quiet video=1024x768"
# Line 50  FORMAT_FILESYSTEM="${DEFAULT_FILESYSTEM} Line 80  FORMAT_FILESYSTEM="${DEFAULT_FILESYSTEM}
80  #  DIALOG BOXEN #  #  DIALOG BOXEN #
81  #################################################  #################################################
82    
83  die()  dialog_die()
84  {  {
85   ERROR=$1   ERROR="$1"
86   RETVAL=$?   RETVAL="$?"
87   dialog_install_failure   dialog_install_failure
88   exit 1   exit 1
89  }  }
90    
91  dialog_warning()  dialog_warning()
92  {  {
93   dialog \   local retval
94   --backtitle "${TITLE}" \  
95   --colors \   yesnobox $"\Z1 !!! Warning !!! \Zn\n\n\This harddrive will be irreversibly erased.\n\n\Do you want to continue ?"
96   --defaultno \   retval=$?
97   --yesno "\Z1 !!! Achtung !!! \Zn\n\n\   if [[ ${retval} -eq 1 ]]
  Diese Festplatte wird unwiederruflich geloescht werden.\n\n\  
  Soll ich wirklich fortfahren ?" 10 70  
  RES=$?  
  if [[ ${RES} -eq 1 ]]  
98   then   then
99   clear   clear
100   echo "Der Vorgang wurde abgebrochen."   echo $"The process was aborted."
101   exit 1   exit 1
102   fi   fi
103  }  }
104    
105  dialog_setup_hdd_info()  dialog_setup_hdd_info()
106  {  {
  local SHDD="$(echo ${HDD} | sed 's/\/dev\///')"  
   
  dialog \  
  --colors \  
  --title "[ Festplatten Partitionierung ]" \  
  --backtitle "${TITLE}" \  
  --ok-label "Weiter" \  
  --msgbox "\nBitte legen Sie 3 Partitionen an.\n\n\  
  [ \Z3${SHDD}1\Zn ] Typ: \Z3Linux\Zn mit ca. 50MB\n\  
  [ \Z3${SHDD}2\Zn ] Typ: \Z3Linux Swap\Zn mit ca. 256MB\n\  
  [ \Z3${SHDD}3\Zn ] Typ: \Z3Linux \Zn mit dem Rest (min. 256MB)\n\n\  
  Bitte ${SHDD}1 als \Z3bootable\Zn markieren." 12 81  
 }  
   
 dialog_setup_hdd_info_flash()  
 {  
107   local SHDD="$(echo $HDD | sed 's/\/dev\///')"   local SHDD="$(echo $HDD | sed 's/\/dev\///')"
108    
109   dialog \   dialog \
# Line 135  dialog_setup_system_menu() Line 145  dialog_setup_system_menu()
145   "" "" \   "" "" \
146   "" "\Z1Experten Modi:\Zn" \   "" "\Z1Experten Modi:\Zn" \
147   "2" "Normale IDE-Disk (Manuell)" \   "2" "Normale IDE-Disk (Manuell)" \
  "3" "Flash-Speicher (Manuell)")  
148   RES=$?   RES=$?
149   [[ ${RES} -eq 1 ]] && return 1   [[ ${RES} -eq 1 ]] && return 1
150   if [[ ${RES} -eq 0 ]]   if [[ ${RES} -eq 0 ]]
151   then   then
152   case "${i}" in   case "${i}" in
153   "1") run_install_auto ;;   "1") run_install_auto ;;
154           "2") run_install_normal ;;   "2") run_install_normal ;;
  "3") run_install_flash ;;  
155   "") dialog_setup_system_menu;;   "") dialog_setup_system_menu;;
156   esac   esac
157   fi   fi
# Line 154  dialog_hardware_detection() Line 162  dialog_hardware_detection()
162   local i   local i
163   local hwtmp   local hwtmp
164    
165   if [ -x $(which mktemp &> /dev/null) ]   if [ -x $(type -P mktemp) ]
166   then   then
167   hwtmp="$(mktemp)"   hwtmp="$(mktemp)"
168   else   else
169   hwtmp="/tmp/hwtmp.sh"   hwtmp="/tmp/hwtmp.sh"
170   fi   fi
171    
172   [[ ! -z ${installdevs} ]] && installdevs=""   run_hardware_detection_disks
173    
174   echo "dialog \\"  > ${hwtmp}   echo "dialog \\"  > ${hwtmp}
175   echo "--backtitle \"${TITLE}\" \\" >> ${hwtmp}   echo "--backtitle \"${TITLE}\" \\" >> ${hwtmp}
# Line 171  dialog_hardware_detection() Line 179  dialog_hardware_detection()
179   echo "--msgbox \"Gefundene Hardware:\n\n \\" >> ${hwtmp}   echo "--msgbox \"Gefundene Hardware:\n\n \\" >> ${hwtmp}
180   echo " Festplatten:\n \\" >> ${hwtmp}   echo " Festplatten:\n \\" >> ${hwtmp}
181    
182   if [[ ! -z ${scsidisks} ]]   if [[ ! -z ${ALL_DISKS} ]]
183   then   then
184   for i in ${scsidisks}   for i in ${ALL_DISKS}
185   do   do
186   if [[ ${i} != ${cdromdev} ]]   echo " \\Z3${i}\\Zn\n \\" >> ${hwtmp}
  then  
  echo " \\Z7SCSI: \\Z3${i}\\Zn\n \\" >> ${hwtmp}  
  installdevs="${installdevs} ${i}"  
  fi  
187   done   done
188   fi   fi
189    
190   if [[ ! -z ${idedisks} ]]   if [[ ! -z ${ALL_CDROMS} ]]
191   then   then
192   for i in ${idedisks}   echo " \n \\" >> ${hwtmp}
193     echo " CDROM Laufwerke:\n \\" >> ${hwtmp}
194     for i in ${ALL_CDROMS}
195   do   do
196   if [[ ${i} != ${cdromdev} ]]   echo " \\Z3${i}\\Zn\n \\" >> ${hwtmp}
  then  
  echo " \\Z7IDE:  \\Z3${i}\\Zn\n \\" >> ${hwtmp}  
  installdevs="${installdevs} ${i}"  
  fi  
197   done   done
198   fi   fi
199    
  if [[ ! -z ${cdromdev} ]]  
  then  
  echo " \n \\" >> ${hwtmp}  
  echo " \\Z7andere Laufwerke:\n \\" >> ${hwtmp}  
  echo " CDROM: \\Z3${cdromdev}\\Zn\n \\" >> ${hwtmp}  
  fi  
   
200   # other devices   # other devices
201   run_hardware_detection   run_hardware_detection
202   case "${SPECIALDEVICE}" in   case "${SPECIALDEVICE}" in
# Line 264  dialog_setup_hdd_partitions_manuell() Line 259  dialog_setup_hdd_partitions_manuell()
259   fi   fi
260  }  }
261    
262  dialog_setup_hdd_partitions_manuell_flash()  dialog_setup_hdd_partitions_auto()
263  {  {
264   local i   local i
265    
# Line 296  dialog_setup_hdd_partitions_manuell_flas Line 291  dialog_setup_hdd_partitions_manuell_flas
291   [[ ${RES} -eq 1 ]] && return 1   [[ ${RES} -eq 1 ]] && return 1
292   if [[ ${RES} -eq 0 ]]   if [[ ${RES} -eq 0 ]]
293   then   then
294   dialog_setup_hdd_info_flash   dialog_setup_hdd_info_auto
295   setup_hdd_partitions_manuell_flash   dialog_setup_hdd_create_partitions
296     setup_hdd_partitions_auto
297   fi   fi
298   fi   fi
299  }  }
300    
301  dialog_setup_hdd_partitions_auto()  run_hardware_detection_disks()
302  {  {
303   local i   local bootdev
304    
305   if [[ -z ${installdevs} ]]   # all disks but exclude ramdisks
306     export ALL_DISKS=$(get_hwinfo disk | sed '/\/dev\/ram[0-9].*/d')
307     # remove the boot device from ALL_DISKS if it was an usbstick
308     if [[ $(grep '[[:space:]]/mnt/cdrom[[:space:]]' /proc/mounts | cut -d' ' -f3) != iso9660 ]]
309   then   then
310   dialog \   bootdev="$(grep '[[:space:]]/mnt/cdrom[[:space:]]' /proc/mounts | cut -d' ' -f1 | sed 's:[0-9]::g')"
311   --backtitle "${TITLE}" \   export ALL_DISKS=$(echo "${ALL_DISKS}" | grep -v "${bootdev}")
  --ok-label "Beenden" \  
  --msgbox "Kein geeignetes Laufwerk gefunden.\nDie Installation ist fehlgeschlagen." 6 70  
  exit 1  
  else  
   
  echo "dialog \\" > /tmp/hddtmp.sh  
  echo "--backtitle \"${TITLE}\" \\" >> /tmp/hddtmp.sh  
  echo "--ok-label \"Weiter\" \\" >> /tmp/hddtmp.sh  
  echo "--cancel-label \"Beenden\" \\" >> /tmp/hddtmp.sh  
  echo "--stdout \\" >> /tmp/hddtmp.sh  
  echo "--menu \"Installations Laufwerk auswaehlen:\" 10 70 3 \\" >> /tmp/hddtmp.sh  
   
  for i in ${installdevs}  
  do  
  echo "\"${i}\" \"\" \\" >> /tmp/hddtmp.sh  
  done  
  echo -e "\n" >> /tmp/hddtmp.sh  
   
  chmod a+x /tmp/hddtmp.sh  
  HDD="$(/tmp/hddtmp.sh)"  
  RES=$?  
  [[ ${RES} -eq 1 ]] && return 1  
  if [[ ${RES} -eq 0 ]]  
  then  
  dialog_setup_hdd_info_auto  
  dialog_setup_hdd_create_partitions  
  setup_hdd_partitions_auto  
  fi  
312   fi   fi
313     export ALL_CDROMS="$(get_hwinfo cdrom)"
314  }  }
315    
316  dialog_setup_hdd_create_partitions()  dialog_setup_hdd_create_partitions()
# Line 429  dialog_main() Line 401  dialog_main()
401   if [[ ${RES} -eq 0 ]]   if [[ ${RES} -eq 0 ]]
402   then   then
403   case ${METHOD} in   case ${METHOD} in
404           "1") dialog_setup_system_menu ;;   "1") dialog_setup_system_menu ;;
405   "2") dialog_hardware_detection ;;   "2") dialog_hardware_detection ;;
406   "3") install_do_reboot ;;   "3") install_do_reboot ;;
407   "4") /bin/bash --login -i ;;   "4") /bin/bash --login -i ;;
# Line 503  hdd_size_below_256mb() Line 475  hdd_size_below_256mb()
475   local hdd="$1"   local hdd="$1"
476   local size   local size
477   local retval   local retval
478   [[ -z ${hdd} ]] && die "Error: get_hdd_size() no \$hdd given!"   [[ -z ${hdd} ]] && dialog_die "Error: get_hdd_size() no \$hdd given!"
479    
480   size=$(fdisk -l ${hdd} | grep "Disk.*${hdd}" | sed 's:.*,\ \(.*\)\ byte.*:\1:')   size=$(fdisk -l ${hdd} | grep "Disk.*${hdd}" | sed 's:.*,\ \(.*\)\ byte.*:\1:')
481   if [[ ${size} -le 257000000 ]]   if [[ ${size} -le 257000000 ]]
# Line 532  setup_hdd_partitions_auto() Line 504  setup_hdd_partitions_auto()
504   fi   fi
505    
506   ## delete disk   ## delete disk
507   dd if=/dev/zero of=${HDD} count=1 &> /dev/null || die   dd if=/dev/zero of=${HDD} count=1 &> /dev/null || dialog_die
508    
509   if [[ ${FDISKPARTIONBELOW256MB} = 1 ]]   if [[ ${FDISKPARTIONBELOW256MB} = 1 ]]
510   then   then
# Line 580  EOF Line 552  EOF
552    
553  setup_hdd_partitions_manuell()  setup_hdd_partitions_manuell()
554  {  {
  BOOTHDD="${HDD}1"  
  SWAPHDD="${HDD}2"  
  ROOTHDD="${HDD}3"  
   
  ## hdds partitionieren manuell  
  cfdisk ${HDD} || die  
 }  
   
 setup_hdd_partitions_manuell_flash()  
 {  
555   ROOTHDD="${HDD}1"   ROOTHDD="${HDD}1"
556    
557   ## hdds partitionieren manuell   ## hdds partitionieren manuell
558   cfdisk ${HDD} || die   cfdisk ${HDD} || dialog_die
559  }  }
560    
561  setup_hdd_format()  setup_hdd_format()
562  {  {
563   mkswap ${SWAPHDD} || die   mke2fs -j -q ${ROOTHDD} || dialog_die
  mke2fs -j -q ${BOOTHDD} || die  
  mke2fs -j -q ${ROOTHDD} || die  
 }  
   
 setup_hdd_format_flash()  
 {  
  mke2fs -j -q ${ROOTHDD} || die  
564  }  }
565    
566  install_mount_rootfs()  install_mount_rootfs()
567  {  {
568   swapon ${SWAPHDD} || die   mount ${ROOTHDD} ${INSTALLROOT} || dialog_die
569   mount ${ROOTHDD} ${INSTALLPATH} || die   install -d ${INSTALLROOT}/boot || dialog_die
570   install -d ${INSTALLPATH}/boot || die   cd ${INSTALLROOT} || dialog_die
  mount ${BOOTHDD} ${INSTALLPATH}/boot || die  
  cd ${INSTALLPATH} || die  
 }  
   
 install_mount_rootfs_flash()  
 {  
  mount ${ROOTHDD} ${INSTALLPATH} || die  
  install -d ${INSTALLPATH}/boot || die  
  cd ${INSTALLPATH} || die  
571  }  }
572    
573  install_system_image()  install_system_image()
574  {  {
575   tar xvjpf ${CDPATH}/system/${CDIMAGENAME} -C ${INSTALLPATH}   tar xvjpf ${CDROOT}/system/${CDIMAGENAME} -C ${INSTALLROOT}
576  }  }
577    
578  install_bootsector_chroot()  install_bootsector_chroot()
579  {  {
580   local my_roothdd   local my_roothdd
581   local grubconf=${INSTALLPATH}/boot/grub/grub.conf   local grubconf=${INSTALLROOT}/boot/grub/grub.conf
582   local grub2conf=/boot/grub/grub.cfg   local grub2conf=/boot/grub/grub.cfg
583    
584   # check for grub2   # check for grub2
585   if [[ -f ${INSTALLPATH}/sbin/grub-mkconfig ]]   if [[ -f ${INSTALLROOT}/sbin/grub-mkconfig ]]
586   then   then
587   # needed by grub-mkconfig on the first run   # needed by grub-mkconfig on the first run
588   if [[ ! -f ${INSTALLPATH}/boot/grub/video.lst ]]   if [[ ! -f ${INSTALLROOT}/boot/grub/video.lst ]]
589   then   then
590   install -m0644 ${INSTALLPATH}/lib/grub/*/video.lst ${INSTALLPATH}/boot/grub/video.lst || die   install -m0644 ${INSTALLROOT}/lib/grub/*/video.lst ${INSTALLROOT}/boot/grub/video.lst || dialog_die
591   fi   fi
592    
593   # set kernelopts   # set kernelopts
594   if [[ -f ${INSTALLPATH}/etc/conf.d/grub ]]   if [[ -f ${INSTALLROOT}/etc/conf.d/grub ]]
595   then   then
596   sed -i "s:^\(export GRUB_CMDLINE_LINUX_DEFAULT=\).*:\1\"${KERNELOPTS}\":" ${INSTALLPATH}/etc/conf.d/grub || die   sed -i "s:^\(export GRUB_CMDLINE_LINUX_DEFAULT=\).*:\1\"${KERNELOPTS}\":" ${INSTALLROOT}/etc/conf.d/grub || dialog_die
597   else   else
598   echo "export GRUB_CMDLINE_LINUX_DEFAULT=\"${KERNELOPTS}\"" >  ${INSTALLPATH}/etc/conf.d/grub || die   echo "export GRUB_CMDLINE_LINUX_DEFAULT=\"${KERNELOPTS}\"" >  ${INSTALLROOT}/etc/conf.d/grub || dialog_die
599   fi   fi
600   echo 'grub-mkdevicemap' > ${INSTALLPATH}/root/.installrc || die   echo 'grub-mkdevicemap' > ${INSTALLROOT}/root/.installrc || dialog_die
601   echo "LC_ALL=C grub-mkconfig -o ${grub2conf}  &> /dev/null" >> ${INSTALLPATH}/root/.installrc || die   echo "LC_ALL=C grub-mkconfig -o ${grub2conf}  &> /dev/null" >> ${INSTALLROOT}/root/.installrc || dialog_die
602   echo "grub-install --no-floppy ${HDD} &> /dev/null" >> ${INSTALLPATH}/root/.installrc || die   echo "grub-install --no-floppy ${HDD} &> /dev/null" >> ${INSTALLROOT}/root/.installrc || dialog_die
603   echo "exit 0" >> ${INSTALLPATH}/root/.installrc || die   echo "exit 0" >> ${INSTALLROOT}/root/.installrc || dialog_die
604    
605   # grub-legacy   # grub-legacy
606   else   else
607   ### grubconf schreiben   ### grubconf schreiben
608   source ${INSTALLPATH}/boot/kernelversion   source ${INSTALLROOT}/boot/kernelversion
609    
610   #for alx only   #for alx only
611   if [ -e ${INSTALLPATH}/etc/alx_version ]   if [ -e ${INSTALLROOT}/etc/alx_version ]
612   then   then
613   OLD_ALXVER="${ALXVER}"   OLD_ALXVER="${ALXVER}"
614   source ${INSTALLPATH}/etc/alx_version   source ${INSTALLROOT}/etc/alx_version
615   KRNVER="ALX-${ALXVER}"   KRNVER="ALX-${ALXVER}"
616   ALXVER="${OLD_ALXVER}"   ALXVER="${OLD_ALXVER}"
617   fi   fi
# Line 682  install_bootsector_chroot() Line 628  install_bootsector_chroot()
628   my_roothdd="${ROOTHDD}"   my_roothdd="${ROOTHDD}"
629   fi   fi
630    
631   : > ${grubconf} || die   : > ${grubconf} || dialog_die
632   echo "default 0" >> ${grubconf} || die   echo "default 0" >> ${grubconf} || dialog_die
633   echo "timeout 3" >> ${grubconf} || die   echo "timeout 3" >> ${grubconf} || dialog_die
634   # using current root password   # using current root password
635   echo "password --md5 $(cat ${INSTALLPATH}/etc/shadow | grep root | cut -d: -f2)"  >> ${grubconf} || die   echo "password --md5 $(cat ${INSTALLROOT}/etc/shadow | grep root | cut -d: -f2)"  >> ${grubconf} || dialog_die
636    
637   echo  >> ${grubconf} || die   echo  >> ${grubconf} || dialog_die
638   echo "# normal boot" >> ${grubconf} || die   echo "# normal boot" >> ${grubconf} || dialog_die
639   echo "title ${KRNVER}" >> ${grubconf} || die   echo "title ${KRNVER}" >> ${grubconf} || dialog_die
640   echo "root (hd0,0)" >> ${grubconf} || die   echo "root (hd0,0)" >> ${grubconf} || dialog_die
641   echo "kernel /boot/${KRNIMG} root=${my_roothdd} ${KERNELOPTS} ${GRUBLEGACYOPTS}" >> ${grubconf} || die   echo "kernel /boot/${KRNIMG} root=${my_roothdd} ${KERNELOPTS} ${GRUBLEGACYOPTS}" >> ${grubconf} || dialog_die
642   if is_initrd_supported   if is_initrd_supported
643   then   then
644   echo "initrd /boot/${KRNINITRD}" >> ${grubconf} || die   echo "initrd /boot/${KRNINITRD}" >> ${grubconf} || dialog_die
645   fi   fi
646    
647   echo >> ${grubconf} || die   echo >> ${grubconf} || dialog_die
648   echo "# admin boot" >> ${grubconf} || die   echo "# admin boot" >> ${grubconf} || dialog_die
649   echo "title ${KRNVER} - Re-run hardware-detection" >> ${grubconf} || die   echo "title ${KRNVER} - Re-run hardware-detection" >> ${grubconf} || dialog_die
650   echo "lock"  >> ${grubconf} || die   echo "lock"  >> ${grubconf} || dialog_die
651   echo "root (hd0,0)" >> ${grubconf} || die   echo "root (hd0,0)" >> ${grubconf} || dialog_die
652   echo "kernel /boot/${KRNIMG} root=${my_roothdd} ${KERNELOPTS} ${GRUBLEGACYOPTS} hardware-auto-detection" >> ${grubconf} || die   echo "kernel /boot/${KRNIMG} root=${my_roothdd} ${KERNELOPTS} ${GRUBLEGACYOPTS} hardware-auto-detection" >> ${grubconf} || dialog_die
653   if is_initrd_supported   if is_initrd_supported
654   then   then
655   echo "initrd /boot/${KRNINITRD}" >> ${grubconf} || die   echo "initrd /boot/${KRNINITRD}" >> ${grubconf} || dialog_die
656   fi   fi
657    
658   echo >> ${grubconf} || die   echo >> ${grubconf} || dialog_die
659   echo "title ${KRNVER} - Reset *all* local settings" >> ${grubconf} || die   echo "title ${KRNVER} - Reset *all* local settings" >> ${grubconf} || dialog_die
660   echo "lock"  >> ${grubconf} || die   echo "lock"  >> ${grubconf} || dialog_die
661   echo "root (hd0,0)" >> ${grubconf} || die   echo "root (hd0,0)" >> ${grubconf} || dialog_die
662   echo "kernel /boot/${KRNIMG} root=${my_roothdd} ${KERNELOPTS} ${GRUBLEGACYOPTS} alx-reset-settings" >> ${grubconf} || die   echo "kernel /boot/${KRNIMG} root=${my_roothdd} ${KERNELOPTS} ${GRUBLEGACYOPTS} alx-reset-settings" >> ${grubconf} || dialog_die
663   if is_initrd_supported   if is_initrd_supported
664   then   then
665   echo "initrd /boot/${KRNINITRD}" >> ${grubconf} || die   echo "initrd /boot/${KRNINITRD}" >> ${grubconf} || dialog_die
666   fi   fi
667    
668   # bootsector schreiben chrooted schreiben (lfs/magellan)   # bootsector schreiben chrooted schreiben (lfs/magellan)
669   cat > ${INSTALLPATH}/root/.installrc << CHROOTEOF   cat > ${INSTALLROOT}/root/.installrc << CHROOTEOF
670  /usr/sbin/grub --no-floppy --batch << "EOF" 1> /dev/null 2> /dev/null  /usr/sbin/grub --no-floppy --batch << "EOF" 1> /dev/null 2> /dev/null
671  root (hd0,0)  root (hd0,0)
672  setup (hd0)  setup (hd0)
# Line 730  exit 0 Line 676  exit 0
676  CHROOTEOF  CHROOTEOF
677   fi   fi
678    
679   ## enters chroot   ## enter chroot
680   mount -t proc proc ${INSTALLPATH}/proc   mount -t proc proc ${INSTALLROOT}/proc
681   mount -t sysfs sysfs ${INSTALLPATH}/sys   mount -t sysfs sysfs ${INSTALLROOT}/sys
682   mount -o bind /dev ${INSTALLPATH}/dev   mount -o bind /dev ${INSTALLROOT}/dev
683   chroot ${INSTALLPATH} /bin/bash --rcfile /root/.installrc -i   chroot ${INSTALLROOT} /bin/bash --rcfile /root/.installrc -i
684   umount ${INSTALLPATH}/proc   umount ${INSTALLROOT}/proc
685   umount ${INSTALLPATH}/sys   umount ${INSTALLROOT}/sys
686   umount ${INSTALLPATH}/dev   umount ${INSTALLROOT}/dev
687   rm ${INSTALLPATH}/root/.installrc   rm ${INSTALLROOT}/root/.installrc
688  }  }
689    
690  is_initrd_supported()  is_initrd_supported()
691  {  {
692   # only generate initrds if the cmd exists   # only generate initrds if the cmd exists
693   [[ -x ${INSTALLPATH}/sbin/mkinitrd ]] && return 0   [[ -x ${INSTALLROOT}/sbin/mkinitrd ]] && return 0
694   return 1   return 1
695  }  }
696    
# Line 775  install_initrd_chroot() Line 721  install_initrd_chroot()
721   fi   fi
722    
723   # install an appropriate uvesafb.conf   # install an appropriate uvesafb.conf
724   install -d ${INSTALLPATH}/etc/modprobe.d || die   install -d ${INSTALLROOT}/etc/modprobe.d || dialog_die
725   echo "options uvesafb mode_option=1024x768-32@60 scroll=ywrap" > ${INSTALLPATH}/etc/modprobe.d/uvesafb.conf || die   echo "options uvesafb mode_option=1024x768-32@60 scroll=ywrap" > ${INSTALLROOT}/etc/modprobe.d/uvesafb.conf || dialog_die
726    
727   # install an appropriate viafb.conf   # install an appropriate viafb.conf
728   echo "options viafb viafb_mode=1024x768 viafb_refresh=60" > ${INSTALLPATH}/etc/modprobe.d/viafb.conf || die   echo "options viafb viafb_mode=1024x768 viafb_refresh=60" > ${INSTALLROOT}/etc/modprobe.d/viafb.conf || dialog_die
729    
730   # install an appropriate i810fb.conf   # install an appropriate i810fb.conf
731   echo "options i810fb xres=1024 yres=768 bpp=16 mtrr=1 hsync1=30 hsync2=62 vsync1=30 vsync2=60"  > ${INSTALLPATH}/etc/modprobe.d/i810fb.conf || die   echo "options i810fb xres=1024 yres=768 bpp=16 mtrr=1 hsync1=30 hsync2=62 vsync1=30 vsync2=60"  > ${INSTALLROOT}/etc/modprobe.d/i810fb.conf || dialog_die
732    
733   cat > ${INSTALLPATH}/root/.installrc << CHROOTEOF   cat > ${INSTALLROOT}/root/.installrc << CHROOTEOF
734  echo "MODULES=\"${FORMAT_FILESYSTEM} ${DISKMODS} ${OLDATAMODS} ${PATAMODS} ${SATAMODS} ${DRMMODS} ${FBMODS} ${OTHERMODS}\"" > /etc/conf.d/mkinitrd  echo "MODULES=\"${FORMAT_FILESYSTEM} ${DISKMODS} ${OLDATAMODS} ${PATAMODS} ${SATAMODS} ${DRMMODS} ${FBMODS} ${OTHERMODS}\"" > /etc/conf.d/mkinitrd
735  mkinitrd -f /boot/$(readlink /boot/initrd) $(readlink /boot/vmlinuz | sed "s:kernel-::g") > /dev/null  mkinitrd -f /boot/$(readlink /boot/initrd) $(readlink /boot/vmlinuz | sed "s:kernel-::g") > /dev/null
736  exit 0  exit 0
737  CHROOTEOF  CHROOTEOF
738    
739   ## enters chroot   ## enters chroot
740   mount -t proc proc ${INSTALLPATH}/proc   mount -t proc proc ${INSTALLROOT}/proc
741   mount -t sysfs sysfs ${INSTALLPATH}/sys   mount -t sysfs sysfs ${INSTALLROOT}/sys
742   mount -o bind /dev ${INSTALLPATH}/dev   mount -o bind /dev ${INSTALLROOT}/dev
743   chroot ${INSTALLPATH} /bin/bash --rcfile /root/.installrc -i   chroot ${INSTALLROOT} /bin/bash --rcfile /root/.installrc -i
744   umount ${INSTALLPATH}/proc   umount ${INSTALLROOT}/proc
745   umount ${INSTALLPATH}/sys   umount ${INSTALLROOT}/sys
746   umount ${INSTALLPATH}/dev   umount ${INSTALLROOT}/dev
747   rm ${INSTALLPATH}/root/.installrc   rm ${INSTALLROOT}/root/.installrc
748  }  }
749    
750  is_uuid_supported()  is_uuid_supported()
751  {  {
752   if [[ -x $(which busybox.mkinitrd &> /dev/null) ]]   if [[ -x $(type -P busybox.mkinitrd) ]]
753   then   then
754   # only detect uuids if supported   # only detect uuids if supported
755   if [[ ! -z $(busybox.mkinitrd | grep blkid) ]]   if [[ ! -z $(busybox.mkinitrd | grep blkid) ]]
# Line 822  get_uuid() Line 768  get_uuid()
768   local TYPE   local TYPE
769    
770   local dev="$1"   local dev="$1"
771   [[ -z ${dev} ]] && die "no dev given"   [[ -z ${dev} ]] && dialog_die "no dev given"
772    
773   # check if given device is already an UUID   # check if given device is already an UUID
774   if [[ ${dev/UUID=/}x != ${dev}x ]]   if [[ ${dev/UUID=/}x != ${dev}x ]]
# Line 839  install_system_settings() Line 785  install_system_settings()
785   # schreibe fstab   # schreibe fstab
786   if is_uuid_supported   if is_uuid_supported
787   then   then
788   echo -e "UUID=$(get_uuid ${BOOTHDD})\t/boot\t${FORMAT_FILESYSTEM}\tnoatime,noauto\t1 1" > ${INSTALLPATH}/etc/fstab || die   echo -e "UUID=$(get_uuid ${ROOTHDD})\t/\t${FORMAT_FILESYSTEM}\tnoatime\t0 0" >> ${INSTALLROOT}/etc/fstab || dialog_die
  echo -e "UUID=$(get_uuid ${ROOTHDD})\t/\t${FORMAT_FILESYSTEM}\tnoatime\t0 0" >> ${INSTALLPATH}/etc/fstab || die  
789   else   else
790   echo -e "${BOOTHDD}\t/boot\t${FORMAT_FILESYSTEM}\tnoatime,noauto\t1 1" > ${INSTALLPATH}/etc/fstab || die   echo -e "${ROOTHDD}\t/\t${FORMAT_FILESYSTEM}\tnoatime\t0 0" >> ${INSTALLROOT}/etc/fstab || dialog_die
  echo -e "${ROOTHDD}\t/\t${FORMAT_FILESYSTEM}\tnoatime\t0 0" >> ${INSTALLPATH}/etc/fstab || die  
791   fi   fi
792   # not needed busybox loads all with swapon -a, even if not mentioned in fstab   # not needed busybox loads all with swapon -a, even if not mentioned in fstab
793   #echo -e "UUID='$(get_uuid ${SWAPHDD})'\tswap\tswap\tpri=1\t0 0" >> ${INSTALLPATH}/etc/fstab || die   #echo -e "UUID='$(get_uuid ${SWAPHDD})'\tswap\tswap\tpri=1\t0 0" >> ${INSTALLROOT}/etc/fstab || dialog_die
794   echo -e "proc\t/proc\tproc\tdefaults\t0 0" >> ${INSTALLPATH}/etc/fstab || die   echo -e "proc\t/proc\tproc\tdefaults\t0 0" >> ${INSTALLROOT}/etc/fstab || dialog_die
795   echo -e "shm\t/dev/shm\ttmpfs\tdefaults\t0 0" >> ${INSTALLPATH}/etc/fstab || die   echo -e "shm\t/dev/shm\ttmpfs\tdefaults\t0 0" >> ${INSTALLROOT}/etc/fstab || dialog_die
796    
797   # install network config skeleton   # install network config skeleton
798   install -m0644 ${INSTALLPATH}/etc/alxconfig-ng/skel/net/net.eth0 ${INSTALLPATH}/etc/conf.d/ || die   install -m0644 ${INSTALLROOT}/etc/alxconfig-ng/skel/net/net.eth0 ${INSTALLROOT}/etc/conf.d/ || dialog_die
799    
800   # intel framebufer quirk   # intel framebufer quirk
801   if [[ -e /proc/fb ]]   if [[ -e /proc/fb ]]
# Line 861  install_system_settings() Line 805  install_system_settings()
805   fbdev=$(grep 'inteldrmfb' /proc/fb | sed 's:\([0-9]\).*:\1:')   fbdev=$(grep 'inteldrmfb' /proc/fb | sed 's:\([0-9]\).*:\1:')
806   if [[ ${fbdev} != 0 ]]   if [[ ${fbdev} != 0 ]]
807   then   then
808   sed -i "s:^\(SPLASH_DEV=\).*:\1\"/dev/fb${fbdev}\":" ${INSTALLPATH}/etc/splash/splash.conf || die   sed -i "s:^\(SPLASH_DEV=\).*:\1\"/dev/fb${fbdev}\":" ${INSTALLROOT}/etc/splash/splash.conf || dialog_die
809   fi   fi
810   fi   fi
811   fi   fi
812  }  }
813    
 install_system_settings_flash()  
 {  
  # schreibe fstab  
  if is_uuid_supported  
  then  
  echo -e "UUID=$(get_uuid ${ROOTHDD})\t/\t${FORMAT_FILESYSTEM}\tnoatime\t0 0" > ${INSTALLPATH}/etc/fstab || die  
  else  
  echo -e "${ROOTHDD}\t/\t${FORMAT_FILESYSTEM}\tnoatime\t0 0" > ${INSTALLPATH}/etc/fstab || die  
  fi  
  echo -e "proc\t/proc\tproc\tdefaults\t0 0" >> ${INSTALLPATH}/etc/fstab || die  
  echo -e "shm\t/dev/shm\ttmpfs\tdefaults\t0 0" >> ${INSTALLPATH}/etc/fstab || die  
 }  
   
814  install_umount_rootfs()  install_umount_rootfs()
815  {  {
816   cd /   cd /
817   umount ${INSTALLPATH}/boot || die   umount ${INSTALLROOT}/boot || dialog_die
818   umount ${INSTALLPATH} || die   umount ${INSTALLROOT} || dialog_die
  swapoff ${SWAPHDD} || die  
 }  
   
 install_umount_rootfs_flash()  
 {  
  cd /  
  umount ${INSTALLPATH} || die  
819  }  }
820    
821  install_do_reboot()  install_do_reboot()
# Line 925  run_install_normal() Line 849  run_install_normal()
849   dialog_install_successful   dialog_install_successful
850  }  }
851    
 run_install_flash()  
 {  
  dialog_hardware_detection  
   
  dialog_setup_hdd_partitions_manuell_flash  
  dialog_setup_hdd_format  
  setup_hdd_format_flash > /dev/null  
  install_mount_rootfs_flash  
  (install_system_image > /tmp/install.log) 2> /tmp/install_errors.log | dialog_install_meter | dialog_install_system_image  
   
  dialog_install_settings  
  sleep 1  
  install_system_settings_flash  
  install_initrd_chroot  
   
  dialog_install_bootsector  
  install_bootsector_chroot  
   
  install_umount_rootfs_flash  
  dialog_install_successful  
 }  
   
852  run_install_auto()  run_install_auto()
853  {  {
854   dialog_hardware_detection   dialog_hardware_detection
855    
856   dialog_setup_hdd_partitions_auto   dialog_setup_hdd_partitions_auto
857   dialog_setup_hdd_format   dialog_setup_hdd_format
858   setup_hdd_format_flash > /dev/null   setup_hdd_format > /dev/null
859   install_mount_rootfs_flash   install_mount_rootfs
860   (install_system_image > /tmp/install.log) 2> /tmp/install_errors.log | dialog_install_meter | dialog_install_system_image   (install_system_image > /tmp/install.log) 2> /tmp/install_errors.log | dialog_install_meter | dialog_install_system_image
861    
862   dialog_install_settings   dialog_install_settings
863   sleep 1   sleep 1
864   install_system_settings_flash   install_system_settings
865   install_initrd_chroot   install_initrd_chroot
866    
867   dialog_install_bootsector   dialog_install_bootsector
868   install_bootsector_chroot   install_bootsector_chroot
869    
870   install_umount_rootfs_flash   install_umount_rootfs
871   dialog_install_successful   dialog_install_successful
872  }  }
873    

Legend:
Removed from v.2332  
changed lines
  Added in v.2403